/*
    remote Task
    乐迪遥控
*/

/* Includes ----------------------------------------------------------------- */
#include "task/user_task.h"
/* USER INCLUDE BEGIN */
#include "remote_control.h"
#include "remote_cmd.h"
#include "gimbal.h"
/* USER INCLUDE END */

/* Private typedef ---------------------------------------------------------- */
/* Private define ----------------------------------------------------------- */
/* Private macro ------------------------------------------------------------ */
/* Private variables -------------------------------------------------------- */
/* USER STRUCT BEGIN */
extern RC_ctrl_t rc_ctrl;
Gimbal_CMD_t remote_cmd;
Gimbal_IMU_t imu;
/* USER STRUCT END */

/* Private function --------------------------------------------------------- */
/* Exported functions ------------------------------------------------------- */
void Task_remote(void *argument) {
  (void)argument; /* 未使用argument，消除警告 */

  
  /* 计算任务运行到指定频率需要等待的tick数 */
  const uint32_t delay_tick = osKernelGetTickFreq() / REMOTE_FREQ;

  osDelay(REMOTE_INIT_DELAY); /* 延时一段时间再开启任务 */

  uint32_t tick = osKernelGetTickCount(); /* 控制任务运行频率的计时 */
  /* USER CODE INIT BEGIN */
	delay_init();
	remote_control_init();
  /* USER CODE INIT END */
  
  while (1) {
    tick += delay_tick; /* 计算下一个唤醒时刻 */
    /* USER CODE BEGIN */

//		osMessageQueueGet(task_runtime.msgq.gimbal.imu, &imu, NULL, 0);
		
		remote_ParseHost(&remote_cmd,&rc_ctrl,&imu);
    osMessageQueueReset(task_runtime.msgq.gimbal.cmd);
    osMessageQueuePut(task_runtime.msgq.gimbal.cmd,&remote_cmd, 0, 0);

    /* USER CODE END */
    osDelayUntil(tick); /* 运行结束，等待下一次唤醒 */
  }
  
}